package com.aitrainer.api.model

import org.hibernate.annotations.Fetch
import org.hibernate.annotations.FetchMode
import javax.persistence.*

@Entity
data class Customer (
        var name: String = "",
        var firstname: String = "",
        var email: String = "",
        var age: Int? = 0,
        var sex: String = "m",
        var active: String = "N",
        var dateAdd: String? = null,
        var dateChange: String? = null,
        var dataPolicyAllowed: Int = 0,
        var admin: Int = 0,
        var trainer: Int = 0,
        var trainerId: Long = 0,
        var password: String? = "",
        var birthYear:Int = 0,
//        var weight: Int = 0,
        var goal: String? = null,
        var fitnessLevel: String = "beginner",
        var bodyType: String? = null,
        var firebaseUid: String? = null,

        @Id @GeneratedValue(strategy = GenerationType.IDENTITY)
        var customerId: Long = 0
) {
        @OneToMany(cascade = [(CascadeType.ALL)], fetch = FetchType.EAGER, mappedBy = "customer")
        @Fetch(value = FetchMode.SUBSELECT)
        var exerciseDevices: List<CustomerExerciseDevice> = mutableListOf<CustomerExerciseDevice>()
}
